Package org.gitana.platform.client.branch

# Class BranchImpl

java.lang.Object
org.gitana.platform.support.GitanaObjectImpl
org.gitana.platform.client.document.DocumentImpl
org.gitana.platform.client.platform.AbstractPlatformDocumentImpl
org.gitana.platform.client.repository.AbstractRepositoryDocumentImpl
org.gitana.platform.client.branch.BranchImpl

All Implemented Interfaces:
  `Serializable`, `Branch`, `Document`, `PlatformDocument`, `RepositoryDocument`, `AccessControllable`, `Copyable`, `Referenceable`, `Selfable`, `TitleDescription`, `Transferable`, `TypedID`, `org.gitana.platform.GitanaObject`, `org.gitana.platform.JSONable`

public class BranchImpl extends AbstractRepositoryDocumentImpl implements Branch

Author:
  uzi
See Also:
  - Serialized Form

## Field Summary

### Fields inherited from class org.gitana.platform.support.GitanaObjectImpl

`serialVersionUID`

### Fields inherited from interface org.gitana.platform.client.branch.Branch

`FIELD_BRANCH_TYPE, FIELD_FROZEN, FIELD_JOIN_BRANCH, FIELD_READONLY, FIELD_ROOT, FIELD_ROOT_BRANCH, FIELD_SNAPSHOT, FIELD_TIP`

### Fields inherited from interface org.gitana.platform.client.document.Document

`FIELD_ID, SYSTEM, SYSTEM_CREATED_BY, SYSTEM_CREATED_ON, SYSTEM_MODIFIED_BY, SYSTEM_MODIFIED_ON`

### Fields inherited from interface org.gitana.platform.client.support.TitleDescription

`FIELD_DESCRIPTION, FIELD_TITLE`

## Constructor Summary

Constructors
Constructor
Description
`BranchImpl(Repository repository, com.fasterxml.jackson.databind.node.ObjectNode obj, boolean isSaved)`

## Method Summary

Modifier and Type
Method
Description
`PermissionCheckResults`
`checkNodePermissions(List<PermissionCheck> list)`
Check node permissions.
`NodeList`
`createList(String listKey, org.gitana.platform.support.QName itemTypeQName)`
Creates a new node list.
`BaseNode`
`createNode()`
Creates an empty node on the branch.
`BaseNode`
`createNode(com.fasterxml.jackson.databind.node.ObjectNode object)`
Creates a node on the branch.
`BaseNode`
`createNode(org.gitana.platform.support.QName typeQName)`
Creates an empty node on the branch.
`Map<String,BaseNode>`
`createNodes(Map<String,String> params, org.gitana.http.HttpPayload... payloads)`
Creates multiple nodes from binary payloads (single attachment each).
`AssociationDefinition`
`defineAssociationType(org.gitana.platform.support.QName definitionQName)`
Creates an association type definition.
`AssociationDefinition`
`defineAssociationType(org.gitana.platform.support.QName definitionQName, com.fasterxml.jackson.databind.node.ObjectNode object)`
Creates an association type definition.
`TypeDefinition`
`defineType(org.gitana.platform.support.QName definitionQName)`
Creates a type definition.
`TypeDefinition`
`defineType(org.gitana.platform.support.QName definitionQName, com.fasterxml.jackson.databind.node.ObjectNode object)`
Creates a type definition.
`void`
`delete()`
Delete
`List<String>`
`deleteNodes(List<String> nodeIds)`
Delete multiple nodes
`boolean`
`equals(Object object)`
`org.gitana.platform.support.ResultMap<BaseNode>`
`findNodes(com.fasterxml.jackson.databind.node.ObjectNode query, String searchTerm)`
Queries and searches for nodes.
`org.gitana.platform.support.ResultMap<BaseNode>`
`findNodes(com.fasterxml.jackson.databind.node.ObjectNode query, String searchTerm, LookupOptions options)`
Queries and searches for nodes.
`org.gitana.platform.support.ResultMap<BaseNode>`
`findNodes(com.fasterxml.jackson.databind.node.ObjectNode query, String searchTerm, org.gitana.platform.support.Pagination pagination)`
Queries and searches for nodes.
`ACL`
`getACL()`
`List<String>`
`getACL(String principalId)`
Retrieve the authorities that a principal has.
`Map<String,Map<String,org.gitana.platform.services.authority.AuthorityGrant>>`
`getAuthorityGrants(List<String> principalIds)`
Acquires a map of authority grants for a set of principals.
`String`
`getJoinBranchId()`
`protected String`
`getResourceUri()`
`String`
`getRootBranchId()`
`String`
`getRootChangesetId()`
`String`
`getTipChangesetId()`
`org.gitana.platform.services.branch.BranchType`
`getType()`
`String`
`getTypeId()`
`void`
`grant(String principalId, String authorityId)`
Grants an authority to a principal.
`void`
`grant(DomainPrincipal principal, String authorityId)`
`com.fasterxml.jackson.databind.node.ObjectNode`
`graphqlQuery(String query)`
Performs a graphql query
`com.fasterxml.jackson.databind.node.ObjectNode`
`graphqlQuery(String query, String operationName, Map<String,Object> variables)`
Performs a graphql query
`String`
`graphqlSchema()`
Finds the graphql schema for types on this branch
`boolean`
`hasAuthority(String principalId, String authorityId)`
Checks whether the principal has the given authority over this object.
`boolean`
`hasAuthority(DomainPrincipal principal, String authorityId)`
`boolean`
`hasPermission(String principalId, String permissionId)`
Checks whether the principal has the given permission over this object.
`boolean`
`hasPermission(DomainPrincipal principal, String authorityId)`
`boolean`
`isFrozen()`
`boolean`
`isMaster()`
`boolean`
`isReadOnly()`
`boolean`
`isSnapshot()`
`Map<org.gitana.platform.support.QName,Definition>`
`listDefinitions()`
Retrieves definitions for the branch
`Map<org.gitana.platform.support.QName,Definition>`
`listDefinitions(DefinitionFilterType filter, boolean custom, boolean system, org.gitana.platform.support.Pagination pagination)`
`org.gitana.platform.support.ResultMap<Node>`
`listNodes()`
Retrieves the mount nodes for this branch.
`org.gitana.platform.support.ResultMap<Node>`
`listNodes(LookupOptions options)`
Retrieves the mount nodes for this branch.
`org.gitana.platform.support.ResultMap<Node>`
`listNodes(org.gitana.platform.support.Pagination pagination)`
Retrieves the mount nodes for this branch.
`void`
`markDirty()`
`void`
`moveNodes(List<String> sourceNodeIds, String targetNodeId)`
`void`
`moveNodes(List<String> sourceNodeIds, String targetNodeId, String targetPath)`
Moves a list of nodes to a configured target node
`void`
`purgeAllDeletions()`
Purges all deletions for the current branch.
`org.gitana.platform.support.ResultMap<Deletion>`
`queryDeletions(com.fasterxml.jackson.databind.node.ObjectNode query)`
Queries for deletions.
`org.gitana.platform.support.ResultMap<Deletion>`
`queryDeletions(com.fasterxml.jackson.databind.node.ObjectNode query, org.gitana.platform.support.Pagination pagination)`
Queries for deletions.
`org.gitana.platform.support.ResultMap<BaseNode>`
`queryNodes(com.fasterxml.jackson.databind.node.ObjectNode query)`
Performs a query for nodes.
`org.gitana.platform.support.ResultMap<BaseNode>`
`queryNodes(com.fasterxml.jackson.databind.node.ObjectNode query, LookupOptions options)`
Performs a query for nodes.
`org.gitana.platform.support.ResultMap<BaseNode>`
`queryNodes(com.fasterxml.jackson.databind.node.ObjectNode query, org.gitana.platform.support.Pagination pagination)`
Performs a query for nodes.
`Definition`
`readDefinition(org.gitana.platform.support.QName qname)`
Reads a definition
`Deletion`
`readDeletion(String nodeId)`
Reads a deletion by node ID.
`Group`
`readGroup(String groupId, boolean createIfNotFound)`
Reads the group object for a security group.
`NodeList`
`readList(String listKey)`
Reads a node list.
`BaseNode`
`readNode(String nodeId)`
Reads a single node from the branch.
`BaseNode`
`readNode(String nodeId, String path)`
Reads a single node from the brancnh.
`BaseNode`
`readNode(String nodeId, LookupOptions options)`
Reads a single node from the brancnh.
`Person`
`readPerson(String userId, boolean createIfNotFound)`
Reads the person object for a security user.
`void`
`reload()`
Reload
`void`
`revoke(String principalId, String authorityId)`
Revokes an authority for a principal.
`void`
`revoke(DomainPrincipal principal, String authorityId)`
`void`
`revokeAll(String principalId)`
Revoke all authorities for a principal.
`void`
`revokeAll(DomainPrincipal principal)`
`Node`
`rootNode()`
`org.gitana.platform.support.ResultMap<BaseNode>`
`searchNodes(com.fasterxml.jackson.databind.node.ObjectNode searchObject)`
Search
`org.gitana.platform.support.ResultMap<BaseNode>`
`searchNodes(com.fasterxml.jackson.databind.node.ObjectNode searchObject, LookupOptions options)`
Search
`org.gitana.platform.support.ResultMap<BaseNode>`
`searchNodes(com.fasterxml.jackson.databind.node.ObjectNode searchObject, org.gitana.platform.support.Pagination pagination)`
Search
`org.gitana.platform.support.ResultMap<BaseNode>`
`searchNodes(String text)`
Full-text search
`org.gitana.platform.support.ResultMap<BaseNode>`
`searchNodes(String text, LookupOptions options)`
Full-text search
`org.gitana.platform.support.ResultMap<BaseNode>`
`searchNodes(String text, org.gitana.platform.support.Pagination pagination)`
Full-text search
`void`
`setRootChangesetId(String rootChangesetId)`
`void`
`setTipChangesetId(String changesetId)`
`Job`
`startCopyFrom(String sourceRepositoryId, String sourceBranchId, List<String> nodeIds, com.fasterxml.jackson.databind.node.ObjectNode config)`
`void`
`update()`
Update

### Methods inherited from class org.gitana.platform.client.repository.AbstractRepositoryDocumentImpl

`getRepository, getRepositoryId, ref`

### Methods inherited from class org.gitana.platform.client.platform.AbstractPlatformDocumentImpl

`copy, copy, copyAsync, copyAsync, exportArchive, exportArchive, exportArchive, getCluster, getDriver, getFactory, getPlatform, getPlatformId, getRemote, importArchive, importArchive, importArchive`

### Methods inherited from class org.gitana.platform.client.document.DocumentImpl

`dateCreated, dateModified, getCreatedBy, getDescription, getId, getModifiedBy, getSystemObject, getTitle, isSaved, mergeProperties, mergePropertyIfExists, reload, reload, setDescription, setId, setSaved, setTitle`

### Methods inherited from class org.gitana.platform.support.GitanaObjectImpl

`_objectGetFloat, _objectGetInt, _objectGetLong, _objectGetObject, _objectGetString, _objectSet, get, getArray, getAsJsonNode, getBigDecimal, getBoolean, getDouble, getInt, getLong, getObject, getObject, getString, has, putAll, putAll, putObject, remove, set, toJSON, toJSONString, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.gitana.platform.client.support.Copyable

`copy, copy, copyAsync, copyAsync`

### Methods inherited from interface org.gitana.platform.client.document.Document

`dateCreated, dateModified, getCreatedBy, getId, getModifiedBy, getSystemObject, isSaved, reload, reload, setId, setSaved`

### Methods inherited from interface org.gitana.platform.GitanaObject

`get, getArray, getAsJsonNode, getBigDecimal, getBoolean, getDouble, getInt, getLong, getObject, getObject, getString, has, putAll, putAll, remove, set`

### Methods inherited from interface org.gitana.platform.JSONable

`toJSON, toJSONString`

### Methods inherited from interface org.gitana.platform.client.platform.PlatformDocument

`getPlatform, getPlatformId`

### Methods inherited from interface org.gitana.platform.client.support.Referenceable

`ref`

### Methods inherited from interface org.gitana.platform.client.repository.RepositoryDocument

`getRepository, getRepositoryId`

### Methods inherited from interface org.gitana.platform.client.support.TitleDescription

`getDescription, getTitle, setDescription, setTitle`

### Methods inherited from interface org.gitana.platform.client.support.Transferable

`exportArchive, exportArchive, exportArchive, importArchive, importArchive, importArchive`

### Methods inherited from interface org.gitana.platform.client.support.TypedID

`getId`

## Constructor Details

### BranchImpl

public BranchImpl(Repository repository, com.fasterxml.jackson.databind.node.ObjectNode obj, boolean isSaved)

## Method Details

### getTypeId

public String getTypeId()

Specified by:
  `getTypeId` in interface `TypedID`

### getResourceUri

protected String getResourceUri()

Specified by:
  `getResourceUri` in class `AbstractPlatformDocumentImpl`

### markDirty

public void markDirty()

Specified by:
  `markDirty` in interface `Branch`

### setTipChangesetId

public void setTipChangesetId(String changesetId)

Specified by:
  `setTipChangesetId` in interface `Branch`

### getTipChangesetId

public String getTipChangesetId()

Specified by:
  `getTipChangesetId` in interface `Branch`

### setRootChangesetId

public void setRootChangesetId(String rootChangesetId)

Specified by:
  `setRootChangesetId` in interface `Branch`

### getRootChangesetId

public String getRootChangesetId()

Specified by:
  `getRootChangesetId` in interface `Branch`

### isReadOnly

public boolean isReadOnly()

Specified by:
  `isReadOnly` in interface `Branch`

### isSnapshot

public boolean isSnapshot()

Specified by:
  `isSnapshot` in interface `Branch`

### isFrozen

public boolean isFrozen()

Specified by:
  `isFrozen` in interface `Branch`

### getJoinBranchId

public String getJoinBranchId()

Specified by:
  `getJoinBranchId` in interface `Branch`

### getRootBranchId

public String getRootBranchId()

Specified by:
  `getRootBranchId` in interface `Branch`

### isMaster

public boolean isMaster()

Specified by:
  `isMaster` in interface `Branch`

### getType

public org.gitana.platform.services.branch.BranchType getType()

Specified by:
  `getType` in interface `Branch`

### equals

public boolean equals(Object object)

Overrides:
  `equals` in class `Object`

### reload

public void reload()
Description copied from interface: `Selfable`
Reload

Specified by:
  `reload` in interface `Selfable`

### update

public void update()
Description copied from interface: `Selfable`
Update

Specified by:
  `update` in interface `Selfable`

### delete

public void delete()
Description copied from interface: `Selfable`
Delete

Specified by:
  `delete` in interface `Selfable`

### getACL

public ACL getACL()

Specified by:
  `getACL` in interface `AccessControllable`
Returns:
  access control list

### getACL

public List<String> getACL(String principalId)
Description copied from interface: `AccessControllable`
Retrieve the authorities that a principal has.

Specified by:
  `getACL` in interface `AccessControllable`
Parameters:
  `principalId` -
Returns:
  list

### grant

public void grant(String principalId, String authorityId)
Description copied from interface: `AccessControllable`
Grants an authority to a principal.

Specified by:
  `grant` in interface `AccessControllable`
Parameters:
  `principalId` -
  `authorityId` -

### grant

public void grant(DomainPrincipal principal, String authorityId)

Specified by:
  `grant` in interface `AccessControllable`

### revoke

public void revoke(String principalId, String authorityId)
Description copied from interface: `AccessControllable`
Revokes an authority for a principal.

Specified by:
  `revoke` in interface `AccessControllable`
Parameters:
  `principalId` -
  `authorityId` -

### revoke

public void revoke(DomainPrincipal principal, String authorityId)

Specified by:
  `revoke` in interface `AccessControllable`

### revokeAll

public void revokeAll(String principalId)
Description copied from interface: `AccessControllable`
Revoke all authorities for a principal.

Specified by:
  `revokeAll` in interface `AccessControllable`
Parameters:
  `principalId` -

### revokeAll

public void revokeAll(DomainPrincipal principal)

Specified by:
  `revokeAll` in interface `AccessControllable`

### hasAuthority

public boolean hasAuthority(String principalId, String authorityId)
Description copied from interface: `AccessControllable`
Checks whether the principal has the given authority over this object.

Specified by:
  `hasAuthority` in interface `AccessControllable`
Parameters:
  `principalId` -
  `authorityId` -
Returns:

### hasAuthority

public boolean hasAuthority(DomainPrincipal principal, String authorityId)

Specified by:
  `hasAuthority` in interface `AccessControllable`

### getAuthorityGrants

public Map<String,Map<String,org.gitana.platform.services.authority.AuthorityGrant>> getAuthorityGrants(List<String> principalIds)
Description copied from interface: `AccessControllable`
Acquires a map of authority grants for a set of principals.

Specified by:
  `getAuthorityGrants` in interface `AccessControllable`
Parameters:
  `principalIds` -
Returns:

### hasPermission

public boolean hasPermission(String principalId, String permissionId)
Description copied from interface: `AccessControllable`
Checks whether the principal has the given permission over this object.

Specified by:
  `hasPermission` in interface `AccessControllable`
Parameters:
  `principalId` -
  `permissionId` -
Returns:

### hasPermission

public boolean hasPermission(DomainPrincipal principal, String authorityId)

Specified by:
  `hasPermission` in interface `AccessControllable`

### listNodes

public org.gitana.platform.support.ResultMap<Node> listNodes()
Description copied from interface: `Branch`
Retrieves the mount nodes for this branch.

Specified by:
  `listNodes` in interface `Branch`
Returns:
  a map of node objects keyed by node id

### listNodes

public org.gitana.platform.support.ResultMap<Node> listNodes(org.gitana.platform.support.Pagination pagination)
Description copied from interface: `Branch`
Retrieves the mount nodes for this branch.

Specified by:
  `listNodes` in interface `Branch`
Parameters:
  `pagination` -
Returns:
  a map of node objects keyed by node id

### listNodes

public org.gitana.platform.support.ResultMap<Node> listNodes(LookupOptions options)
Description copied from interface: `Branch`
Retrieves the mount nodes for this branch.

Specified by:
  `listNodes` in interface `Branch`
Parameters:
  `options` -
Returns:
  a map of node objects keyed by node id

### readNode

public BaseNode readNode(String nodeId)
Description copied from interface: `Branch`
Reads a single node from the branch.

Specified by:
  `readNode` in interface `Branch`
Parameters:
  `nodeId` -
Returns:
  node

### readNode

public BaseNode readNode(String nodeId, String path)
Description copied from interface: `Branch`
Reads a single node from the brancnh.

Specified by:
  `readNode` in interface `Branch`
Parameters:
  `nodeId` -
  `path` -
Returns:
  node

### readNode

public BaseNode readNode(String nodeId, LookupOptions options)
Description copied from interface: `Branch`
Reads a single node from the brancnh.

Specified by:
  `readNode` in interface `Branch`
Parameters:
  `nodeId` -
  `options` -
Returns:
  node

### createNode

public BaseNode createNode()
Description copied from interface: `Branch`
Creates an empty node on the branch.

Specified by:
  `createNode` in interface `Branch`
Returns:
  branch

### createNode

public BaseNode createNode(org.gitana.platform.support.QName typeQName)
Description copied from interface: `Branch`
Creates an empty node on the branch.

Specified by:
  `createNode` in interface `Branch`
Parameters:
  `typeQName` -
Returns:
  branch

### createNode

public BaseNode createNode(com.fasterxml.jackson.databind.node.ObjectNode object)
Description copied from interface: `Branch`
Creates a node on the branch.

Specified by:
  `createNode` in interface `Branch`
Parameters:
  `object` -
Returns:
  node

### createNodes

public Map<String,BaseNode> createNodes(Map<String,String> params, org.gitana.http.HttpPayload... payloads)
Description copied from interface: `Branch`
Creates multiple nodes from binary payloads (single attachment each).

Specified by:
  `createNodes` in interface `Branch`
Parameters:
  `params` -
  `payloads` -
Returns:

### queryNodes

public org.gitana.platform.support.ResultMap<BaseNode> queryNodes(com.fasterxml.jackson.databind.node.ObjectNode query)
Description copied from interface: `Branch`
Performs a query for nodes.

Specified by:
  `queryNodes` in interface `Branch`
Parameters:
  `query` -
Returns:
  map of nodes

### queryNodes

public org.gitana.platform.support.ResultMap<BaseNode> queryNodes(com.fasterxml.jackson.databind.node.ObjectNode query, org.gitana.platform.support.Pagination pagination)
Description copied from interface: `Branch`
Performs a query for nodes.

Specified by:
  `queryNodes` in interface `Branch`
Parameters:
  `query` -
  `pagination` -
Returns:
  map of nodes

### queryNodes

public org.gitana.platform.support.ResultMap<BaseNode> queryNodes(com.fasterxml.jackson.databind.node.ObjectNode query, LookupOptions options)
Description copied from interface: `Branch`
Performs a query for nodes.

Specified by:
  `queryNodes` in interface `Branch`
Parameters:
  `query` -
  `options` -
Returns:
  map of nodes

### searchNodes

public org.gitana.platform.support.ResultMap<BaseNode> searchNodes(String text)
Description copied from interface: `Branch`
Full-text search

Specified by:
  `searchNodes` in interface `Branch`
Parameters:
  `text` -
Returns:
  map of nodes

### searchNodes

public org.gitana.platform.support.ResultMap<BaseNode> searchNodes(String text, org.gitana.platform.support.Pagination pagination)
Description copied from interface: `Branch`
Full-text search

Specified by:
  `searchNodes` in interface `Branch`
Parameters:
  `text` -
  `pagination` -
Returns:
  map of nodes

### searchNodes

public org.gitana.platform.support.ResultMap<BaseNode> searchNodes(String text, LookupOptions options)
Description copied from interface: `Branch`
Full-text search

Specified by:
  `searchNodes` in interface `Branch`
Parameters:
  `text` -
  `options` -
Returns:
  map of nodes

### searchNodes

public org.gitana.platform.support.ResultMap<BaseNode> searchNodes(com.fasterxml.jackson.databind.node.ObjectNode searchObject)
Description copied from interface: `Branch`
Search

Specified by:
  `searchNodes` in interface `Branch`
Parameters:
  `searchObject` -
Returns:
  map of nodes

### searchNodes

public org.gitana.platform.support.ResultMap<BaseNode> searchNodes(com.fasterxml.jackson.databind.node.ObjectNode searchObject, org.gitana.platform.support.Pagination pagination)
Description copied from interface: `Branch`
Search

Specified by:
  `searchNodes` in interface `Branch`
Parameters:
  `searchObject` -
  `pagination` -
Returns:
  map of nodes

### searchNodes

public org.gitana.platform.support.ResultMap<BaseNode> searchNodes(com.fasterxml.jackson.databind.node.ObjectNode searchObject, LookupOptions options)
Description copied from interface: `Branch`
Search

Specified by:
  `searchNodes` in interface `Branch`
Parameters:
  `searchObject` -
  `options` -
Returns:
  map of nodes

### deleteNodes

public List<String> deleteNodes(List<String> nodeIds)
Description copied from interface: `Branch`
Delete multiple nodes

Specified by:
  `deleteNodes` in interface `Branch`
Parameters:
  `nodeIds` -
Returns:
  list of node ids deleted

### moveNodes

public void moveNodes(List<String> sourceNodeIds, String targetNodeId)

Specified by:
  `moveNodes` in interface `Branch`

### moveNodes

public void moveNodes(List<String> sourceNodeIds, String targetNodeId, String targetPath)
Description copied from interface: `Branch`
Moves a list of nodes to a configured target node

Specified by:
  `moveNodes` in interface `Branch`
Parameters:
  `sourceNodeIds` - list of nodes to move
  `targetNodeId` - id of target folder, default is "root" for top folder
  `targetPath` - optional relative path to apply to targetNodeId for determining move target

### rootNode

public Node rootNode()

Specified by:
  `rootNode` in interface `Branch`

### checkNodePermissions

public PermissionCheckResults checkNodePermissions(List<PermissionCheck> list)
Description copied from interface: `Branch`
Check node permissions.

Specified by:
  `checkNodePermissions` in interface `Branch`
Parameters:
  `list` -
Returns:

### readPerson

public Person readPerson(String userId, boolean createIfNotFound)
Description copied from interface: `Branch`
Reads the person object for a security user.

Specified by:
  `readPerson` in interface `Branch`
Parameters:
  `userId` - userId
  `createIfNotFound` - whether to create the person object if it isn't found
Returns:
  Person node

### readGroup

public Group readGroup(String groupId, boolean createIfNotFound)
Description copied from interface: `Branch`
Reads the group object for a security group.

Specified by:
  `readGroup` in interface `Branch`
Parameters:
  `groupId` - groupd ID
  `createIfNotFound` - whether to create the group object if it isn't found
Returns:
  Group node

### listDefinitions

public Map<org.gitana.platform.support.QName,Definition> listDefinitions()
Description copied from interface: `Branch`
Retrieves definitions for the branch

Specified by:
  `listDefinitions` in interface `Branch`
Returns:
  a map of node objects keyed by node id

### listDefinitions

public Map<org.gitana.platform.support.QName,Definition> listDefinitions(DefinitionFilterType filter, boolean custom, boolean system, org.gitana.platform.support.Pagination pagination)

Specified by:
  `listDefinitions` in interface `Branch`

### readDefinition

public Definition readDefinition(org.gitana.platform.support.QName qname)
Description copied from interface: `Branch`
Reads a definition

Specified by:
  `readDefinition` in interface `Branch`
Parameters:
  `qname` -
Returns:
  node

### defineType

public TypeDefinition defineType(org.gitana.platform.support.QName definitionQName)
Description copied from interface: `Branch`
Creates a type definition.

Specified by:
  `defineType` in interface `Branch`
Returns:
  node

### defineType

public TypeDefinition defineType(org.gitana.platform.support.QName definitionQName, com.fasterxml.jackson.databind.node.ObjectNode object)
Description copied from interface: `Branch`
Creates a type definition.

Specified by:
  `defineType` in interface `Branch`
Parameters:
  `definitionQName` -
  `object` -
Returns:

### defineAssociationType

public AssociationDefinition defineAssociationType(org.gitana.platform.support.QName definitionQName)
Description copied from interface: `Branch`
Creates an association type definition.

Specified by:
  `defineAssociationType` in interface `Branch`
Parameters:
  `definitionQName` -
Returns:

### defineAssociationType

public AssociationDefinition defineAssociationType(org.gitana.platform.support.QName definitionQName, com.fasterxml.jackson.databind.node.ObjectNode object)
Description copied from interface: `Branch`
Creates an association type definition.

Specified by:
  `defineAssociationType` in interface `Branch`
Parameters:
  `definitionQName` -
  `object` -
Returns:

### findNodes

public org.gitana.platform.support.ResultMap<BaseNode> findNodes(com.fasterxml.jackson.databind.node.ObjectNode query, String searchTerm)
Description copied from interface: `Branch`
Queries and searches for nodes.

Specified by:
  `findNodes` in interface `Branch`
Parameters:
  `query` -
  `searchTerm` -
Returns:

### findNodes

public org.gitana.platform.support.ResultMap<BaseNode> findNodes(com.fasterxml.jackson.databind.node.ObjectNode query, String searchTerm, org.gitana.platform.support.Pagination pagination)
Description copied from interface: `Branch`
Queries and searches for nodes.

Specified by:
  `findNodes` in interface `Branch`
Parameters:
  `query` -
  `searchTerm` -
  `pagination` -
Returns:

### findNodes

public org.gitana.platform.support.ResultMap<BaseNode> findNodes(com.fasterxml.jackson.databind.node.ObjectNode query, String searchTerm, LookupOptions options)
Description copied from interface: `Branch`
Queries and searches for nodes.

Specified by:
  `findNodes` in interface `Branch`
Parameters:
  `query` -
  `searchTerm` -
  `options` -
Returns:

### createList

public NodeList createList(String listKey, org.gitana.platform.support.QName itemTypeQName)
Description copied from interface: `Branch`
Creates a new node list.

Specified by:
  `createList` in interface `Branch`
Parameters:
  `listKey` -
  `itemTypeQName` -
Returns:
  node list

### readList

public NodeList readList(String listKey)
Description copied from interface: `Branch`
Reads a node list.

Specified by:
  `readList` in interface `Branch`
Parameters:
  `listKey` -
Returns:
  node list

### readDeletion

public Deletion readDeletion(String nodeId)
Description copied from interface: `Branch`
Reads a deletion by node ID.

Specified by:
  `readDeletion` in interface `Branch`
Parameters:
  `nodeId` -
Returns:
  deletion

### queryDeletions

public org.gitana.platform.support.ResultMap<Deletion> queryDeletions(com.fasterxml.jackson.databind.node.ObjectNode query)
Description copied from interface: `Branch`
Queries for deletions.

Specified by:
  `queryDeletions` in interface `Branch`
Parameters:
  `query` -
Returns:
  result map of deletions

### queryDeletions

public org.gitana.platform.support.ResultMap<Deletion> queryDeletions(com.fasterxml.jackson.databind.node.ObjectNode query, org.gitana.platform.support.Pagination pagination)
Description copied from interface: `Branch`
Queries for deletions.

Specified by:
  `queryDeletions` in interface `Branch`
Parameters:
  `query` -
  `pagination` -
Returns:
  result map of deletions

### purgeAllDeletions

public void purgeAllDeletions()
Description copied from interface: `Branch`
Purges all deletions for the current branch.

Specified by:
  `purgeAllDeletions` in interface `Branch`

### graphqlQuery

public com.fasterxml.jackson.databind.node.ObjectNode graphqlQuery(String query)
Description copied from interface: `Branch`
Performs a graphql query

Specified by:
  `graphqlQuery` in interface `Branch`
Parameters:
  `query` -
Returns:

### graphqlQuery

public com.fasterxml.jackson.databind.node.ObjectNode graphqlQuery(String query, String operationName, Map<String,Object> variables)
Description copied from interface: `Branch`
Performs a graphql query

Specified by:
  `graphqlQuery` in interface `Branch`
Parameters:
  `query` -
  `operationName` -
  `variables` -
Returns:
  query results json

### graphqlSchema

public String graphqlSchema()
Description copied from interface: `Branch`
Finds the graphql schema for types on this branch

Specified by:
  `graphqlSchema` in interface `Branch`
Returns:
  schema string

### startCopyFrom

public Job startCopyFrom(String sourceRepositoryId, String sourceBranchId, List<String> nodeIds, com.fasterxml.jackson.databind.node.ObjectNode config)

Specified by:
  `startCopyFrom` in interface `Branch`